// background.js
console.log('我是后台js...');
//

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

//返回html
async function fetch_request_common(url){
     var return_html = '';
     let options = {
         //mode:'no-cors',
         //mode:'cors',
         //"Access-Control-Allow-Origin":"*",
         //"Access-Control-Allow-Methods": "HEAD, GET, POST, PUT, PATCH, DELETE",
         //"Access-Control-Allow-Headers": "Origin, Content-Type, X-Auth-Token",
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8',
             //"Content-Type": "text/plain;charset=UTF-8"
         },
         //referrer: url,
         //referrerPolicy: "no-referrer-when-downgrade",
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}


function yellowpages_co_tg_get_shangjia_data(req_url=''){

}
/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */




//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'yellowpages_co_tg_get_shangjia_data') {
        // console.log('action',request,sender,sendResponse);
        //let shangjia_data = yellowpages_co_tg_get_shangjia_data(request.req_url);

        let _html_result = ajax_get(request.req_url);
        if (_html_result) {
            if (_html_result!='error') {
                let shangjia_name = '';
                let shangjia_website = '';
                let shangjia_tel = '';
                let shangjia_category = '';
                let shangjia_address = '';
                let shangjia_email = '';
                let shangjia_line = '';
                //
                //console.log(req_url+' success' + data);
                //
                let _res_jquery = $(_html_result);
                //第一种方式
                shangjia_name = _res_jquery.find('.wg-address .address-data').eq(0).find('.col-md-9').text();
                shangjia_address = _res_jquery.find('.wg-address .no-gutter.address-data').eq(0).find('.col-md-9').text();
                _res_jquery.find('.wg-address .address-data').find('a').each(
                    function () {
                        let a_href = $(this).attr('href');
                        if (a_href.indexOf('tel') != -1) {
                            shangjia_tel += a_href.replace('tel:', '') + '   ';
                        }
                    }
                );
                //
                shangjia_line = _res_jquery.find('.wg-address .address-data').find('a.showLineID').attr('data-lineid');
                //
                _res_jquery.find('.wg-address .address-data').find('a').each(
                    function () {
                        let a_href = $(this).attr('href');
                        if (a_href.indexOf('mailto') != -1) {
                            shangjia_email += a_href.replace('mailto:', '') + '   ';
                        }
                    }
                );
                //
                _res_jquery.find('.wg-address .address-data').find('a').each(
                    function () {
                        let a_href = $(this).attr('href');
                        if (a_href.indexOf('http') != -1) {
                            shangjia_website += a_href + '   ';
                        }
                    }
                );
                //

                //第二种方式
                if (!shangjia_address) {
                    shangjia_address = _res_jquery.find('.contact-list .item-business-name').text();
                }
                if (!shangjia_tel) {
                    shangjia_tel = _res_jquery.find('.contact-list .item-telno').text();
                }
                if (!shangjia_email) {
                    shangjia_email = _res_jquery.find('.contact-list .item-email').text();
                }
                if (!shangjia_website) {
                    shangjia_website = _res_jquery.find('.contact-list .item-website').text();
                }
                //
                var shangjia_info = {
                    'Domain': request.req_url,
                    'Yellowpages Url': request.req_url,
                    'Name': shangjia_name,
                    'Website': shangjia_website,
                    'Phone': shangjia_tel,
                    'Email': shangjia_email,
                    'Line': shangjia_line,
                    'Category': shangjia_category,
                    'Address': shangjia_address
                };
                console.log('shangjia_info');
                console.log(shangjia_info);
                console.log('shangjia_info_json:' + JSON.stringify(shangjia_info));
                sendResponse({state:JSON.stringify(shangjia_info)});
                //sendResponse({state: 'aaa'})
                //return shangjia_info;
                //$('.pager-nav').append('已提取完成<br />');
            } else {
                sendResponse({state: JSON.stringify({
                        'Domain':'',
                        'Yellowpages Url': request.req_url,
                    })});
                //return null;
                //对于访问异常的请求,直接过滤
                //$('.pager-nav').append(shangjia_yellopages_url+'未采集到，可以尝试稍后刷新下当前页(或者更换代理再刷新)，会重新采集<br />');
            }
    }

    }
  }
);